// EzLpt1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "EzLpt1.h"
#include "EzLpt1Dlg.h"

#define FORMFEED 12
#define LINEFEED 10
#define CR 13
#define ESC 27
#define BARCODE ?

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEzLpt1Dlg dialog

CEzLpt1Dlg::CEzLpt1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEzLpt1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEzLpt1Dlg)
	m_Edit1 = _T(" ");
	m_Edit2 = _T("742-17-90");
	m_Edit3 = _T(", ,34,.212.");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEzLpt1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEzLpt1Dlg)
	DDX_Control(pDX, IDC_READABLE, m_ReadAble);
	DDX_Control(pDX, IDC_PRINTS_NUMBER, m_Prints);
	DDX_Control(pDX, IDC_FONT3, m_Font3);
	DDX_Control(pDX, IDC_COMBO_FONT2, m_Font2);
	DDX_Control(pDX, IDC_COMBO_FONT1, m_Font1);
	DDX_Text(pDX, IDC_EDIT1, m_Edit1);
	DDV_MaxChars(pDX, m_Edit1, 32);
	DDX_Text(pDX, IDC_EDIT2, m_Edit2);
	DDV_MaxChars(pDX, m_Edit2, 16);
	DDX_Text(pDX, IDC_EDIT3, m_Edit3);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_LABEL20, m_Gap20);
	DDX_Control(pDX, IDC_LABEL43, m_Gap43);
	DDX_Control(pDX, IDC_LABEL50, m_Gap50);
	DDX_Control(pDX, IDC_LPT1, m_PortLpt1);
	DDX_Control(pDX, IDC_LPT2, m_PortLpt2);

}

BEGIN_MESSAGE_MAP(CEzLpt1Dlg, CDialog)
	//{{AFX_MSG_MAP(CEzLpt1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEzLpt1Dlg message handlers

BOOL CEzLpt1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	hLpt = INVALID_HANDLE_VALUE;
	
	int z;
	CString str;
	m_Font1.ResetContent();
	for(z=1;z<15;z++)
		{
			str.Format("%02d",z);
			m_Font1.AddString(str);
		}
	m_Font1.SetCurSel(2);

	m_Font2.ResetContent();
	for(z=1;z<15;z++)
		{
			str.Format("%02d",z);
			m_Font2.AddString(str);
		}
	m_Font2.SetCurSel(1);

	m_Font3.ResetContent();
	for(z=10;z<21;z++)
		{
			str.Format("%2d",z);
			m_Font3.AddString(str);
		}
	m_Font3.SetCurSel(0);
	m_Prints.ResetContent();
	for(z=1;z<21;z++)
		{
			str.Format("%02d",z);
			m_Prints.AddString(str);
		}
	m_Prints.SetCurSel(0);
	m_Gap43.SetCheck(1);
	m_PortLpt1.SetCheck(1);
	m_ReadAble.SetCheck(1);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEzLpt1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEzLpt1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEzLpt1Dlg::OnButton1() 
{
//int z;
	CString str;
	CloseLpt();
	if(!InitLpt(1)){ MessageBox("!Unable to open LPT port!", "Error!",MB_OK);return;}
	
UpdateData();	

//m_Edit1.OemToAnsi();
m_Edit1.AnsiToOem();
m_Edit3.AnsiToOem();

sprintf((char *)szData,"%c%s",ESC,"B");// begin
WriteLpt();

	if(m_Gap20.GetCheck())
		{
			sprintf((char *)szData,"%c%s",ESC,"Q184");// lenght = 20 mm
			WriteLpt();
		}
	else if(m_Gap43.GetCheck())
		{
			sprintf((char *)szData,"%c%s",ESC,"Q168");// lenght = 25 mm
			WriteLpt();
		}
	else
		{
			sprintf((char *)szData,"%c%s",ESC,"Q128");// lenght = 40 mm
			WriteLpt();
		}
// Q189 168 128 048
//sprintf((char *)szData,"%c",FORMFEED);
//WriteLpt();
sprintf((char *)szData,"%c%s",ESC,"S2");// speed = 2
WriteLpt();
sprintf((char *)szData,"%c%s",ESC,"D5");// darkness = 5
WriteLpt();
sprintf((char *)szData,"%c%s",ESC,"M07"); // set left margin
WriteLpt();
str.Empty();
m_Font1.GetLBText(m_Font1.GetCurSel(),str);
sprintf((char *)szData,"%cA%s",ESC,str);// set text size
WriteLpt();
sprintf((char *)szData,"%s%c",(LPCSTR)m_Edit1,CR);
//sprintf((char *)szData,"%s%c","Payment TIME",CR);
WriteLpt();
sprintf((char *)szData,"%c%s",ESC,"?3"); // code39
//sprintf((char *)szData,"%c%s",ESC,"?E"); // barcode EAN (8-13)
WriteLpt();
//sprintf((char *)szData,"%c%s",ESC,"A06");
str.Empty();
m_Font3.GetLBText(m_Font3.GetCurSel(),str);
sprintf((char *)szData,"%cA%s",ESC,str);// set text size
WriteLpt();
sprintf((char *)szData,"%c%s",ESC,"M08");
WriteLpt();
//sprintf((char *)szData,"%s%c","--code39--",CR);
//WriteLpt();
if(m_ReadAble.GetCheck())
	{
		sprintf((char *)szData,"%c{%s}%c",ESC,(LPCSTR)m_Edit2,CR);
		WriteLpt();
	}
else 
	{
		sprintf((char *)szData,"%c|%s}%c",ESC,(LPCSTR)m_Edit2,CR);
		WriteLpt();
	}
sprintf((char *)szData,"%c%s",ESC,"M07"); // set left margin
WriteLpt();
str.Empty();
m_Font2.GetLBText(m_Font2.GetCurSel(),str);
sprintf((char *)szData,"%cA%s",ESC,str);// set text size
WriteLpt();
sprintf((char *)szData,"%s%c",(LPCSTR)m_Edit3,CR);
//sprintf((char *)szData,"%s%c","Payment TIME",CR);
WriteLpt();

//sprintf((char *)szData,"%c",FORMFEED);
//WriteLpt();

sprintf((char *)szData,"%c%s",ESC,"E");// begin
WriteLpt();

str.Empty();
m_Prints.GetLBText(m_Prints.GetCurSel(),str);
sprintf((char *)szData,"%cP%s",ESC,str);// number of copyes
WriteLpt();

//sprintf((char *)szData,);
//spiteLpt();
//fprintf(stdprn,"%c",CR);
//fprintf(stdprn,"%c%s",ESC,"A11");
//fprintf(stdprn,"%s%c","10.24",CR);
//fprintf(stdprn,"%c%s",ESC,"A10");
//fprintf(stdprn,,"F1");
CloseLpt();
}

BOOL CEzLpt1Dlg::InitLpt(int nLpt)
{
//	DCB dcb;
if(m_PortLpt1.GetCheck()) hLpt = CreateFile ("LPT1", GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
else hLpt = CreateFile ("LPT2", GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
//	hLpt = CreateFile ("LPT1", GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);
//	m_hComm = CreateFile((LPCTSTR)strCommPort, GENERIC_READ | GENERIC_WRITE,
//                 0, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);
	if (hLpt == INVALID_HANDLE_VALUE) 
	{
		MessageBox("  LPT !", "!",MB_OK);
		return FALSE;
	}

	/*	  
	GetCommState(m_hComm,&dcb);
	SetupComm (m_hComm, 256, 256);       // allocate transmit & receive buffer
    //dcb.BaudRate = CBR_115200;
	dcb.BaudRate = CBR_9600;
	dcb.ByteSize = 8;
    dcb.Parity = NOPARITY;
    dcb.StopBits = ONESTOPBIT;
    SetCommState (m_hComm, &dcb);
	SetCommMask(m_hComm, EV_BREAK | EV_RXCHAR);
	*/
	return TRUE;
}

BOOL CEzLpt1Dlg::CloseLpt()
{
	if(hLpt != INVALID_HANDLE_VALUE)
		{
			CloseHandle(hLpt);
			hLpt = INVALID_HANDLE_VALUE;
		}

	return TRUE;
}

void CEzLpt1Dlg::OnDestroy() 
{
	//CloseLpt();
	CDialog::OnDestroy();
	// TODO: Add your message handler code here
	
}

BOOL CEzLpt1Dlg::WriteLpt()
{
	DWORD dwBytes;
	int nLen,z;
	nLen = strlen((char *)szData);
	//char c;
	//c='a';
	//WriteFile(m_hComm, &c, 1, &dwBytes, NULL);
z=WriteFile(hLpt, &szData, nLen, &dwBytes, NULL);
TRACE("\nWriting to LPT1. Res:%d,Data:%s",z,(char *)szData);
if(z>0)return TRUE;else return FALSE;
}


void CEzLpt1Dlg::OnOK() 
{
	// TODO: Add extra validation here
	
	//CDialog::OnOK();
}

void CEzLpt1Dlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	CloseLpt();
	CDialog::OnCancel();
}
